// Isabela Gallego -- 6451105 -- design t03 --
// Projeto Final: Quadredoscópio

// *Comentários:
//declaração da variável da quantidade de formas que vai desenhar
//as imagens.

int n = 8;

// variáveis responsáveis pelo tamanho das formas.

int tq; 
int tc;
int tt1;
int tt2;
int tt3;
int tt4;

//vetores responsáveis pelo posicionamento das formas e 
//pela velocidade com que vão se locomover.

float x[] = new float [n];
float y[] = new float [n];
float incx[] = new float [n];
float incy[] = new float [n];

//vetor responsável pela variação de cor.

color cor[] = new color [n];

void setup(){
  
 //definição do tamanho inicial das formas.
 
  tq = 20;
  tc = 15;
  tt1 = 5;
  tt2 = 12;
  tt3 = 8;
  tt4 = 16;
  
//tamanho da tela, cor de fundo, sem linha e com boa definição.

  size (800,600);
  background (0);
  noStroke();
  smooth();
  
//desenha um quadrado branco na posição (100,100).
// que será espelhado, formando o fundo do quadredoscópio.

  fill (255);
  rect (100,100,100,100);
  
//desenha os botões
 
  rect (700,150,30,30);
  rect (700,200,30,30);
  rect (700,250,30,30);
  rect (700,300,30,30);
  rect (700,350,30,30);
  rect (700,400,30,30);
  rect (700,450,30,30);
  
//desenha os padrões de decoração da interface.
//linhas superiores e inferiores.

  fill(200);
  rect (500,0,300,20);
  rect (0,0,100,20);
  rect (0,580,800,20);
  fill(120);
  rect (500,20,300,20);
  rect (0,20,100,20);
  rect (0,560,800,20);
  fill(50);
  rect (500,40,300,20);
  rect (0,40,100,20);
  rect (0,540,800,20);
  
//carrega as fontes Platelet Heavy, e Platelet. 
//escreve o nome do programa, e as legendas dos botões.

  PFont fontA = loadFont("PlateletHeavy-48.vlw");
  smooth();
  textFont(fontA,60);
  fill(255);
  text("quadredoscópio",110,50);
 
 PFont fontB = loadFont("Platelet-48.vlw");
  smooth();
  textFont(fontB,18);
  fill(255);
  text("trocar cor",610,170);
  text ("parar", 650,220);
  text ("continuar", 620,270);
  text ("formas grandes", 580,320);
  text ("formas médias", 585,370);
  text ("formas pequenas", 570,420);
  text ("atualizar direções", 545,470);
  
 
  
 
//um for que atualiza aleatoriamente a posição, a velocidade
//e a cor com que as formas aparecem toda vez que o programa 
//é iniciado.
  
  for (int i = 0; i< n; i++) {
    x[i] = random (100, 200);
    y[i] = random (100, 200);
    incx[i] = random (-2,2);
    incy[i] = random (-2,2);
    cor[i] = color(random(0,255),random(0,255),random(0,255));
  }
}

//draw criado para que as formas desenhadas se movimentem dentro do
//espaço do quadrado 100x100 [criado na posição (100,100)].

void draw (){
  
//desenha o quadrado branco que servirá como tranparência
//durante a movimentação das formas.

  fill (255,255,255,4);
  rect (100,100,100,100);
  
//um for criado para desenhar as formas que formam as imagens e 
//para atualizar as suas posições, fazendo com que as formas se 
//movimentem com velocidade aleatória.

  for (int i = 0; i< n; i++) { 
    fill (cor[i]); 
    rect (x[i],y[i],tq,tq);
    ellipse (x[i],y[i],tc,tc);
    triangle (x[i],y[i]-tt1, x[i]+tt3,y[i]+tt2, x[i]-tt4,y[i]+tt2);
    x[i] = x[i] + incx[i];
    y[i] = y[i] + incy[i];
    
//if que faz as formas rebaterem ao chegarem no limite definido.
//esse limite é maior do que o quadrado branco 100x100.

    if (x[i] >200 || x[i]<100) {
      incx[i] = -incx[i];
    }
    if (y[i] >200 || y[i]<100) {
      incy[i] = -incy[i];
    }
    
//máscaras que fecham o desenho no limite do quadrado branco
//já que as formas rebatem num limite maior, para criar imagens
//mais bonitas.
  
  fill (0);
  rect (30,70,230,30);
  rect (30,100,70,200);
  }
  
//cria a função de 5 dos 7 botões.

  if (mousePressed) {
    
//se o mouse for pressionado na área delimitada as cores das
//formas devem variar.
 
   if (700<mouseX && mouseX<730 && 150<mouseY && mouseY<180) {
      for (int i = 0; i< n; i++) {
     cor[i] = color(random(0,255),random(0,255),random(0,255));
     
    }
  }
  
//se o mouse for pressionado na área delimitada o tamanho das
//formas deve aumentar.

  if (700<mouseX && mouseX<730 && 300<mouseY && mouseY<330) {
       tq = 40;
       tc = 30;
       tt1 = 10;
       tt2 = 24;
       tt3 = 16;
       tt4 = 32;
    }
    
//se o mouse for pressionado na área delimitada o tamanho das
//formas volta a ser o tamanho inicial.

    if (700<mouseX && mouseX<730 && 350<mouseY && mouseY<380) {
      tq = 20;
      tc = 15;
      tt1 = 5;
      tt2 = 12;
      tt3 = 8;
      tt4 = 16;
  }
  
//se o mouse for pressionado na área delimitada o tamanho das 
//formas deve diminuir.

    if (700<mouseX && mouseX<730 && 400<mouseY && mouseY<430) {
      tq = 10;
      tc = 7;
      tt1 = 3;
      tt2 = 6;
      tt3 = 4;
      tt4 = 8;
  }
  
//se o mouse for pressionado na área delimitada a direção das 
//formas é atualizada, assim como suas velocidades.

  if (700<mouseX && mouseX<730 && 450<mouseY && mouseY<480) {
      for (int i = 0; i< n; i++){
      incx[i] = random (-2,2);
      incy[i] = random (-2,2);
   
    }
  }
   
  }
    
//cria-se uma função que deverá rodar no draw.
//essa é uma função do espelhamento do quadrado branco inicial
//de tamanho 100x100.

  criaEspelhos();
}

//função criaEpelhos, responsável pelos espelhamentos.

void criaEspelhos() {

//devido a descoberta da função get, foi possível pegar um retalho
//da tela do processing e trabalhar esse retalho como uma imagem.
//o retalho escolhido foi o quadrado branco 100x100. 
//(onde as formas estariam se movimentando)

  PImage retalho = get (100,100,100,100);
 
//função que serve para espelhar a imagem selecionada.
//espelhamento feito no eixo x.

  pushMatrix(); 
  scale(-1.0, 1.0); 
  image(retalho,-300,100); 
  popMatrix ();
  
//mais uma vez utilizando a função get, foi selecionado a área
//do quadrado branco inicial, mais o seu espelhamento.(feito acima)

  retalho = get (100,100,200,100);

//função que serve para espelhar a imagem selecionada.
//espelhamento feito no eixo y.

  pushMatrix(); 
  scale(1.0, -1.0); 
  image(retalho,100,-300); 
  popMatrix ();
  
//função get selecionou o quadrado inicial, e os espelhamentos
//feitos e copiou e essa seleção três vezes, formando assim o
//quadresdoscópio.

  retalho = get (100,100,200,200);
  image(retalho, 300,100);
  image(retalho, 100,300);
  image(retalho, 300,300);
}

//void mousePressed para criar a função de dois botões do programa.
//esse void é criado a parte, devido ao uso de noLoop, que deverá 
//ser utilizado para pausar o draw. esse por sua vez
//poderá voltar a rodar, quando acionada a função loop.

void mousePressed() {
  
//se o mouse for pressionado na área delimitada o draw pára de 
//rodar. assim o programa pára como está.

    if (700<mouseX && mouseX<730 && 200<mouseY && mouseY<230) {
     noLoop ();
    }
    
//se o mouse for pressionado na área delimitada o draw volta
//a funcionar.

    if (700<mouseX && mouseX<730 && 250<mouseY && mouseY<280) {
     loop();
   }
     
}
